%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%2345678901234567890123456789012345678901234567890123456789012345678901234567890
%        1         2         3         4         5         6         7         8

\documentclass[letterpaper, 10 pt, conference]{ieeeconf}  % Comment this line out if you need a4paper

%\documentclass[a4paper, 10pt, conference]{ieeeconf}      % Use this line for a4 paper

\IEEEoverridecommandlockouts                              % This command is only needed if 
                                                          % you want to use the \thanks command

\overrideIEEEmargins                                      % Needed to meet printer requirements.

% See the \addtolength command later in the file to balance the column lengths
% on the last page of the document

% The following packages can be found on http:\\www.ctan.org
%\usepackage{graphics} % for pdf, bitmapped graphics files
\usepackage{graphicx}
%\usepackage{epsfig} % for postscript graphics files
%\usepackage{mathptmx} % assumes new font selection scheme installed
%\usepackage{times} % assumes new font selection scheme installed
%\usepackage{amsmath} % assumes amsmath package installed
%\usepackage{amssymb}  % assumes amsmath package installed
\usepackage[]{algorithm2e}

\title{\LARGE \bf
Reinforcement Learning for Robotics -- Final Project Report
}


\author{Georg Aures and Emmanouil Seferis and \"Om\"ur Y{\i}ld{\i}r{\i}m}


\begin{document}



\maketitle
\thispagestyle{empty}
\pagestyle{empty}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{abstract}

In this paper we apply three different reinforcement learning approaches to solve three tasks. For the model based approach we used the Gaussian Process for the model with the PILCO library. As a model free approach we implemented the POWER algorithm together with a crafted set of functions for the policy. As a more advanced approach we researched various implementations of the Q-learning algorithm and explored their efficiency. Section \ref{COMPARISON} contains a comparison of the approaches and their advantages and shortcomings.

\end{abstract}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{THE THREE TASKS}

This paper examines the performance of three different approaches on a mass-spring-damper (MSD) system, a cart-pole (CP) and a double pendulum (DP). For the MSD-system the behavior of different damping coefficients and for the CP the algorithms are applied with different initial angles. We modeled each system by solving the differential equations for the derivative of the state without poles in the working space.

\section{MODEL BASED APPROACH WITH GP}

As a model based approach we chose PILCO [\ref{pilco}] and adapted the system-behavior and its initial states for our purposes.  

\subsection{PILCO}
The strength of the Gaussian Process (GP) model is the capability of modeling uncertainty. Furthermore these prediction uncertainties are propagated through time by folding the underlying Gaussian distributions. PILCO computes the gradient in the predicted state space analytically.
\subsection{Results}
\paragraph{MSD-system} The Gaussian-Process-Model is capable of identifying the system behavior quite good already after the first 3 second long episode. Learning time is ruffly 2 times longer for the damping coefficient $c=2Ns/m$ in comparison to no damping. A possible explanation for this is, that a damped system contains all frequencies and the damper free system not. The learning time for $c=0.2Ns/m$ is in between the learning time for high or no damping and thus we can assume a relation of the nonlinearity of the system and the learning time.
\paragraph{cart-pole (CP)} Learning requires only a few episodes. The GP is capable of modeling the dynamics of the problem. 
\paragraph{double pendulum (DP)} For the CP theoretically any control force exceeding the maximum friction amplitude should be sufficient for solving the task. The same can not be said for the double pendulum. If the amplitude of the control force is to small the goal was not even approached.

\section{POWER-algorithm}
As a model -- free algorithm for task 2, the POWER algorithm was used. Power is a
relatively simple algorithm: starting from random policy parameters, it runs some
rollouts, collects their rewards, and keeps the best of them. With them, the policy
parameters are updated, as a weighted average of the total rewards accumulated.
The process is then repeated until the policy converges. The algorithm's pseudocode
can be seen below:

\begin{algorithm} %[H]
	\KwData{Data}
	\KwResult{Result}
	$n \leftarrow 0$\;
	\While{policy does not converge}{
		Exploration: collect $\hat{\sigma}$ rollouts based on a chosen strategy\;
		Evaluation: compute the collected rewards and store the best $\sigma$ rollouts\;
		Policy Update:
		$\theta_{n+1}^* = \theta_n^* + \frac{\sum_{i\in\left[ 1,\sigma\right]} (\theta_i - \theta_n^*)R_{\theta_i}}{\sum_{i\in\left[ 1,\sigma\right] } R_{\theta_i}}$\;
		$n \leftarrow n + 1$\;
	}

\caption{POWER-algorithm}
\end{algorithm}

The usual strategy to collect the rollouts is by randomly perturbing the parameters
of the current policy with a Gaussian function. We used a Gaussian with mean 0 and
a variance that went smaller, as the policy converged. Apart from that, we also kept
the best rollouts from the previous round, to improve convergence.

\subsection{results}

For the spring -- mass system, a simple linear policy was sufficient to control the
system, as can be seen below:

\begin{figure}[h]
\centering
\includegraphics[width=0.7\linewidth]{damper}
\caption{POWER-algortihm pushing MSD-system to the goal state}
\label{fig:damper}
\end{figure}


In the cases of cart pole and pendulum, the linear policy was not sufficient. We tried
to construct a modified linear policy that contained sinusoidal terms, but the results

were not much satisfactory. Thus, we can see that the POWER algorithm is one the
one hand model free, but depends on the other hand heavily on the policy model we
choose. A good -- generic policy expression can yield good results, but if an
insufficient prior policy model is chosen, the algorithm is unable to proceed.

\section{Q-LEARNING}

Q-learning (Watkins, 1989) is a simple way for agents to learn how to act optimally in controlled Markovian domains. It amounts to an incremental method for dynamic programming which imposes limited computational demands. It works by successively improving its evaluations of the quality of particular actions at particular states.

For achiving this, Q-learning needs to find of optimal policy for given state. Throught array of trials algorithm find outs a Q-value which represents the quality (desirability) of possible action on given state. Throught trials and mistakes, if the enviroment has stable characteristic,  Q-values of possible actions will get a stable point and optimal policy of given state will be the action with highest Q-value.

To use Q-learning algorithms more accurately or simply solve a problem, continious dimentions must be discretized and state-space must be reduced as much as possible. If state-space has more member this will lead to longer learning time and at some point not accurate results.

\subsection{example}

\begin{algorithm} %[H]
	\KwData{this text}
	\KwResult{how to write algorithm with \LaTeX2e }
	initialization\;
	\While{not at end of this document}{
		read current\;
		\eIf{understand}{
			go to next section\;
			current section becomes this one\;
		}{
		go back to the beginning of current section\;
	}
}
\caption{How to write algorithms}
\end{algorithm}

\subsection{Algorithm}

Algorithm
Define learning rate (alpha) and exploration rate (epsilon)
for  times of episode count
set start state
while desired state is not achieved
select an action for given state
apply the action and get next state, reward
get the best q value from table for given state
\[update q table for given state and action learning_rate*(reward + discount_factor*(best_q) - q_table[state_0 + (action,)])                \]
update learning rate and exploration rate

return q table

\section{COMPARISON AND DISCUSSION}\label{COMPARISON}

In this section we compare the approaches with respect to accuracy, number of interactions with the external world, learning time, prior knowledge required, control energy.

\paragraph{accuracy}

For CP and DP the algorithms can not be measured by accuracy. For the MDS-system the GP-model-approach is more accurate in comparison to the model-free approach.

\paragraph{number of interactions with the external world}

The GP-model-approach needs least interactions because the model is capable of inter- and extrapolating the state-space. If Q-Learning is applied to a small number of discrete states it needs less interactions. The number of interaction for the POWER depends on the number of policy-parameters and on the prior knowledge included in the set of policies.

\paragraph{learning time}

The learning time performance of Q-Learning is outperforming the other approaches. The POWER-algorithm is fast because it avoids costly computations in state-space. GP-modeling is costly because of its O(3) modeling complexity.

\paragraph{prior knowledge required}

The POWER-algorithm can be supplied with a high degree of prior knowledge by choosing the set of policy-functions. GP-models take prior knowledge in the form of the chose of the covariance function. The Q-Learning approach needs a discretized space which can be seen as a form of prior knowledge.

\paragraph{control energy}

We did not observe any difference in the amount of control energy used.

\paragraph{implementation complexity}

Model based approaches are complex to implement because of the additional need to design the model. For the POWER-algorithm it is necessary to supply a set of policy functions. For Q-Learning discretization of the state space can be challenging.

\section{CONCLUSIONS}

In this paper we applied GP-model learning, Q-Learning and the POWER algorithm to MSD-system, CP and DP. We found GP-model learning to need the least number of real world interactions; POWER can be fast if the system is unknown but there exits a general expression for the policy; Q-Learning is better for complex environments with few prior knowledge.   

\addtolength{\textheight}{-12cm}   % This command serves to balance the column lengths
                                  % on the last page of the document manually. It shortens
                                  % the textheight of the last page by a suitable amount.
                                  % This command does not take effect until the next page
                                  % so it should come on the page before the last. Make
                                  % sure that you do not shorten the textheight too much.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





\begin{thebibliography}{99}

\bibitem{c1}\label{pilco} DEISENROTH, Marc; RASMUSSEN, Carl E. PILCO: A model-based and data-efficient approach to policy search. In: Proceedings of the 28th International Conference on machine learning (ICML-11). 2011. S. 465-472.


\end{thebibliography}




\end{document}
